FileUtils#ln_r

12/23/2010 10:25 AM - trans (Thomas Sawyer)

Status: Closed   

Priority: Normal   

Assignee: mame (Yusuke Endoh)   

Target version:    

Description

=begin

I wrote a method for FileUtils to do recursive hard linking. It works just like cp_r but links instead of copies.

The code can be found along with the pull request I made to ruby/ruby on Github:

http://github.com/ruby/ruby/pull/4#issuecomment-631067

It's a pretty handy method for "staging" read-only files. For example I've used it to stage test fixture files in a tmp testing location and

I've used it collect together a set of files for packaging into a tarball.

=end

Associated revisions

Revision d583ee266bf189a8d41ee3a3469ab0334c8643fa - 03/13/2018 08:18 AM - mame (Yusuke Endoh)

Add FileUtils#cp_lr

lib/fileutils.rb: Add FileUtils#cp_lr.  This method creates hard links

of each file from directory to another directory recursively.

This patch is based on Thomas Sawyers and Zachary Scott.

[Feature #4189] [ruby-core:33820]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@62739 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision d583ee26 - 03/13/2018 08:18 AM - mame (Yusuke Endoh)

Add FileUtils#cp_lr

lib/fileutils.rb: Add FileUtils#cp_lr.  This method creates hard links

of each file from directory to another directory recursively.

This patch is based on Thomas Sawyers and Zachary Scott.

[Feature #4189] [ruby-core:33820]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@62739 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 04/22/2011 12:13 PM - naruse (Yui NARUSE)

- Status changed from Open to Assigned

- Assignee set to matz (Yukihiro Matsumoto)

=begin

=end

#2 - 04/22/2011 01:03 PM - matz (Yukihiro Matsumoto)

=begin

Since ln command does not have -r option, I am kind of hesitating to add ln_r.  I understand usefulness of the method.  But I am not sure yet where to

add (is fileutils the best place?), and what to add (is ln_r the best name for the method?).

matz.

=end

#3 - 04/22/2011 01:16 PM - sakuro (Sakuro OZAWA)

=begin

FYI
http://github.com/ruby/ruby/pull/4#issuecomment-631067


X11 distribution has lndir command, it creates real directories and file symlinks though.

=end

#4 - 04/25/2011 05:33 AM - johan556 (Johan Holmberg)

=begin

GNU cp has the -l option, so I think the proposed method is similiar to "cp -lr" on Linux systems.

=end

#5 - 06/24/2012 06:54 AM - reset (Jamie Winsor)

This ticket hasn't seen action in a year, but I wanted to chime in and +1 the feature.

Having a convenience function to recursively create hard links based on a source directory is a rare need, but a need, nonetheless. I think FileUtils is

a fine place for it when compared to the other choices of where to place it in Ruby core.

#6 - 11/19/2012 07:09 AM - zzak (zzak _)

- File fileutils_ln_r.patch added

- Description updated

Adding Thomas' patch from github.

#7 - 11/24/2012 10:54 AM - mame (Yusuke Endoh)

- Target version set to 2.6

#8 - 11/29/2017 08:56 AM - matz (Yukihiro Matsumoto)

Accepted, but I am against the name ln_r because it behaves differently from ln -r (relative).

Matz.

#9 - 11/29/2017 08:59 AM - akr (Akira Tanaka)

After discussion at the developer meeting, cp_lr may be an consensus.

#10 - 12/25/2017 06:14 PM - naruse (Yui NARUSE)

- Target version deleted (2.6)

#11 - 03/08/2018 08:33 AM - mame (Yusuke Endoh)

- File fileutils_cp_lr.patch added

I'll commit this patch that introduces FileUtils.cp_lr in a few days.  Let me know if there is a problem.

#12 - 03/08/2018 08:33 AM - mame (Yusuke Endoh)

- Assignee changed from matz (Yukihiro Matsumoto) to mame (Yusuke Endoh)

#13 - 03/13/2018 08:18 AM - mame (Yusuke Endoh)

- Status changed from Assigned to Closed

Applied in changeset trunk|r62739.

Add FileUtils#cp_lr

lib/fileutils.rb: Add FileUtils#cp_lr.  This method creates hard links

of each file from directory to another directory recursively.

This patch is based on Thomas Sawyers and Zachary Scott.

[Feature #4189] [ruby-core:33820]

Files

fileutils_ln_r.patch 4.72 KB 11/19/2012 zzak (zzak _)

fileutils_cp_lr.patch 4.72 KB 03/08/2018 mame (Yusuke Endoh)
